<?php
/**
@Mod: Opencart Module Benchmarks Monitoring
@Version: 1.0
@Author: Hahuy - www.hahuy.com
@Contact, support: admin@hahuy.com
@Date: March 2014
*/
if (empty($_SERVER['HTTP_X_REQUESTED_WITH']) || (strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest')) {

	if (true) {
		$endtime = microtime();
		$endtime = explode(' ', $endtime);
		$endtime = $endtime['1'] + $endtime['0'];

		$highlight = array('SELECT', 'DISTINCT', 'FROM', 'WHERE', 'AND', 'LEFT&nbsp;JOIN', 'ORDER&nbsp;BY', 'GROUP&nbsp;BY', 'LIMIT', 'INSERT', 'INTO', 'VALUES', 'UPDATE', 'OR&nbsp;', 'HAVING', 'OFFSET', 'NOT&nbsp;IN', 'IN', 'LIKE', 'NOT&nbsp;LIKE', 'COUNT', 'MAX', 'MIN', 'ON', 'AS', 'AVG', 'SUM', '(', ')');
		if ( ! function_exists('highlight_code'))
		{
			function highlight_code($str)
			{
				$str = str_replace(array('&lt;', '&gt;'), array('<', '>'), $str);
				$str = str_replace(array('<?', '?>', '<%', '%>', '\\', '</script>'),
						array('phptagopen', 'phptagclose', 'asptagopen', 'asptagclose', 'backslashtmp', 'scriptclose'), $str);
				$str = '<?php '.$str.' ?>'; // <?
				$str = highlight_string($str, TRUE);
				if (abs(PHP_VERSION) < 5)
				{
					$str = str_replace(array('<font ', '</font>'), array('<span ', '</span>'), $str);
					$str = preg_replace('#color="(.*?)"#', 'style="color: \\1"', $str);
				}

				$str = preg_replace('/<span style="color: #([A-Z0-9]+)">&lt;\?php(&nbsp;| )/i', '<span style="color: #$1">', $str);
				$str = preg_replace('/(<span style="color: #[A-Z0-9]+">.*?)\?&gt;<\/span>\n<\/span>\n<\/code>/is', "$1</span>\n</span>\n</code>", $str);
				$str = preg_replace('/<span style="color: #[A-Z0-9]+"\><\/span>/i', '', $str);

				$str = str_replace(array('phptagopen', 'phptagclose', 'asptagopen', 'asptagclose', 'backslashtmp', 'scriptclose'),
						array('&lt;?', '?&gt;', '&lt;%', '%&gt;', '\\', '&lt;/script&gt;'), $str);

				return $str;
			}
		}
		$time_db = 0;
		foreach ($db->query_data as $query)
		{
			$time_db += $query['time'];
		}
		?>
		<div style='clear:both; background-color:#fff; padding:10px;'>

		<fieldset style="border:1px solid #900;padding:6px 10px 10px 10px; margin:10px 0 10px 0;background-color:#eee">
		<legend style="color:#900; margin-bottom: 0px;">&nbsp;&nbsp;BENCHMARKS&nbsp;&nbsp;</legend>
			<table style='width:100%'>
			<tr><td style='padding:5px;width:50%;color:#000;font-weight:bold;background-color:#ddd;'>Loading Time:&nbsp;&nbsp;</td><td style='padding:5px;width:50%;color:#900;font-weight:normal;background-color:#ddd;'><?php echo number_format($endtime - $starttime, 4); unset($starttime); unset($endtime); ?>s</td></tr>
			<tr><td style='padding:5px;width:50%;color:#000;font-weight:bold;background-color:#ddd;'>Memory Usage:&nbsp;&nbsp;</td><td style='padding:5px;width:50%;color:#900;font-weight:normal;background-color:#ddd;'><?php echo number_format(memory_get_usage()) ?> bytes</td></tr>
			<tr><td style='padding:5px;width:50%;color:#000;font-weight:bold;background-color:#ddd;'>Database Query Count:&nbsp;&nbsp;</td><td style='padding:5px;width:50%;color:#900;font-weight:normal;background-color:#ddd;'><?php echo count($db->query_data) ?></td></tr>
			<tr><td style='padding:5px;width:50%;color:#000;font-weight:bold;background-color:#ddd;'>Database Query Time:&nbsp;&nbsp;</td><td style='padding:5px;width:50%;color:#900;font-weight:normal;background-color:#ddd;'><?php echo number_format($time_db, 4) ?>s</td></tr>
			</table>
		</fieldset>

		<fieldset style="border:1px solid #0000FF;padding:6px 10px 10px 10px;margin:20px 0 20px 0;background-color:#eee">
		<legend style="color:#0000FF; margin-bottom: 0px;">&nbsp;&nbsp;DATABASE:&nbsp; <?php echo DB_DATABASE?>&nbsp;&nbsp;&nbsp;QUERIES&nbsp;&nbsp;(<span style="cursor: pointer;" onclick="var s=document.getElementById('profiler_queries_db').style;s.display=s.display=='none'?'':'none';this.innerHTML=this.innerHTML=='Hide'?'Show':'Hide';">Show</span>)</legend>
			<table style='width:100%; display: none;' id='profiler_queries_db'>
					<?php 
					$price = array();
					foreach ($db->query_data as $key => $row)
					{
						$price[$key] = $row['time'];
					}
					array_multisort($price, SORT_DESC, $db->query_data);
						foreach ($db->query_data as $query)
						{
							$query['query'] = highlight_code($query['query'], ENT_QUOTES);
							foreach ($highlight as $bold)
							{
								$query['query'] = str_replace($bold, '<strong>'.$bold.'</strong>', $query['query']);
							}
							echo "<tr><td style='padding:5px; vertical-align: top;width:1%;color:#900;font-weight:normal;background-color:#ddd;'>".$query['time']."&nbsp;&nbsp;</td><td style='padding:5px; color:#000;font-weight:normal;background-color:#ddd;'>".$query['query']."</td></tr>\n";
						}
					?>
			</table>
		</fieldset>
		</div>
		<?php
	}
}
?>